use crate::error::AdventError;

pub trait AdventDayPart1 {
    fn read_input(&mut self) -> Result<(),AdventError>;
    fn solve(&mut self) -> Result<u64, AdventError>;
}

pub trait AdventDayPart2 {
    fn read_input(&mut self) -> Result<(),AdventError>;
    fn solve(&mut self) -> Result<u64, AdventError>;
}

pub trait AdventDay {
    fn puzzle1(&mut self) -> Result<u64, AdventError>;
    fn puzzle2(&mut self) -> Result<u64, AdventError>;
}

pub mod day1;
pub mod day2;
pub mod day3;
pub mod day4;
pub mod day5;
pub mod day6;

pub mod day14;

/*
fn read_input_part1(part1: &mut Day5Part1, path: &Path) -> Result<(), AdventError> {
    Ok(())
}

fn solve_part1(part1: &mut Day5Part1) -> Result<u64, AdventError> {
    Ok(0)
}

fn read_input_part2(part2: &mut Day5Part2, path: &Path) -> Result<(), AdventError> {
    Ok(())
}

fn solve_part2(part2: &mut Day5Part2) -> Result<u64, AdventError> {
    Ok(0)
}
*/